diff --git a/docs/Docs.vcxproj b/docs/Docs.vcxproj
index 9f8e5fe..2d187d2 100644
--- a/docs/Docs.vcxproj
+++ b/docs/Docs.vcxproj
@@ -52,9 +52,10 @@ builddocs.bat
     <None Include="en_US\connect.rst" />
     <None Include="en_US\control-server.rst" />
     <None Include="en_US\debugger.rst" />
+    <None Include="en_US\default-xsl.rst" />
     <None Include="en_US\editgrid.rst" />
     <None Include="en_US\export.rst" />
-    <None Include="en_US\extended.rst" />
+    <None Include="en_US\extend.rst" />
     <None Include="en_US\gqb.rst" />
     <None Include="en_US\grantwiz.rst" />
     <None Include="en_US\gridopts.rst" />
@@ -87,7 +88,8 @@ builddocs.bat
     <None Include="en_US\query.rst" />
     <None Include="en_US\reports.rst" />
     <None Include="en_US\restore.rst" />
-    <None Include="en_US\search.rst" />
+    <None Include="en_US\sample-xml.rst" />
+    <None Include="en_US\search_object.rst" />
     <None Include="en_US\slony-example.rst" />
     <None Include="en_US\slony-execute.rst" />
     <None Include="en_US\slony-functions.rst" />
diff --git a/docs/Docs.vcxproj.filters b/docs/Docs.vcxproj.filters
index f4b26a4..2d375d4 100644
--- a/docs/Docs.vcxproj.filters
+++ b/docs/Docs.vcxproj.filters
@@ -93,9 +93,6 @@
     <None Include="en_US\export.rst">
       <Filter>en_US</Filter>
     </None>
-    <None Include="en_US\extended.rst">
-      <Filter>en_US</Filter>
-    </None>
     <None Include="en_US\gqb.rst">
       <Filter>en_US</Filter>
     </None>
@@ -192,9 +189,6 @@
     <None Include="en_US\restore.rst">
       <Filter>en_US</Filter>
     </None>
-    <None Include="en_US\search.rst">
-      <Filter>en_US</Filter>
-    </None>
     <None Include="en_US\slony-example.rst">
       <Filter>en_US</Filter>
     </None>
@@ -789,5 +783,17 @@
     <None Include="fi_FI\hints\view-without-pk.html">
       <Filter>fi_FI\hints</Filter>
     </None>
+    <None Include="en_US\default-xsl.rst">
+      <Filter>en_US</Filter>
+    </None>
+    <None Include="en_US\extend.rst">
+      <Filter>en_US</Filter>
+    </None>
+    <None Include="en_US\sample-xml.rst">
+      <Filter>en_US</Filter>
+    </None>
+    <None Include="en_US\search_object.rst">
+      <Filter>en_US</Filter>
+    </None>
   </ItemGroup>
 </Project>
\ No newline at end of file
diff --git a/docs/en_US/backup.rst b/docs/en_US/backup.rst
index 606aafa..f46cd01 100644
--- a/docs/en_US/backup.rst
+++ b/docs/en_US/backup.rst
@@ -1,9 +1,9 @@
 .. _backup:
 
 
-******
-Backup
-******
+***************
+`Backup`:index:
+***************
 
 .. image:: images/backup.png
 .. image:: images/backup-2.png
diff --git a/docs/en_US/bugreport.rst b/docs/en_US/bugreport.rst
index 9ee941d..63a50b9 100644
--- a/docs/en_US/bugreport.rst
+++ b/docs/en_US/bugreport.rst
@@ -1,9 +1,9 @@
 .. _bugreport:
 
 
-*************
-Bug Reporting
-*************
+**********************
+`Bug Reporting`:index:
+**********************
 
 If you think you encountered a bug in pgAdmin III, please check the
 following:
diff --git a/docs/en_US/commandline.rst b/docs/en_US/commandline.rst
index f889f14..eae7a9c 100644
--- a/docs/en_US/commandline.rst
+++ b/docs/en_US/commandline.rst
@@ -1,9 +1,9 @@
 .. _commandline:
 
 
-***********************
-Command Line Parameters
-***********************
+********************************
+`Command Line Parameters`:index:
+********************************
 
 There are a number of command line options that may be passed to the pgAdmin executable
 when starting it.
diff --git a/docs/en_US/connect-error.rst b/docs/en_US/connect-error.rst
index 8949631..75f6e59 100644
--- a/docs/en_US/connect-error.rst
+++ b/docs/en_US/connect-error.rst
@@ -1,9 +1,9 @@
 .. _connect-error:
 
 
-*****************
-Connection errors
-*****************
+**************************
+`Connection errors`:index:
+**************************
 
 When connecting to a PostgreSQL server, you might get error messages
 that need some more explanations. If you encounter them, please read the
diff --git a/docs/en_US/connect.rst b/docs/en_US/connect.rst
index 4e5e064..c5d0c10 100644
--- a/docs/en_US/connect.rst
+++ b/docs/en_US/connect.rst
@@ -1,9 +1,9 @@
 .. _connect:
 
 
-*****************
-Connect to server
-*****************
+**************************
+`Connect to server`:index:
+**************************
 
 .. image:: images/server.png
 
diff --git a/docs/en_US/control-server.rst b/docs/en_US/control-server.rst
index 8c6fc2f..7ba7c16 100644
--- a/docs/en_US/control-server.rst
+++ b/docs/en_US/control-server.rst
@@ -1,9 +1,9 @@
 .. _control-server:
 
 
-**************
-Control Server
-**************
+***********************
+`Control Server`:index:
+***********************
 
 If you entered correct data in the :ref:`Server <connect>`
 property dialogue service field, pgAdmin will check if the service is
diff --git a/docs/en_US/debugger.rst b/docs/en_US/debugger.rst
index a7186cc..71b0c54 100644
--- a/docs/en_US/debugger.rst
+++ b/docs/en_US/debugger.rst
@@ -1,9 +1,9 @@
 .. _debugger:
 
 
-****************
-pgAdmin Debugger
-****************
+*************************
+`pgAdmin Debugger`:index:
+*************************
 
 .. image:: images/debugger.png
 
diff --git a/docs/en_US/default-xsl.rst b/docs/en_US/default-xsl.rst
index baf6413..36e725a 100644
--- a/docs/en_US/default-xsl.rst
+++ b/docs/en_US/default-xsl.rst
@@ -1,9 +1,9 @@
 .. _default-xsl:
 
 
-**********************
-Default XSL Stylesheet
-**********************
+*******************************
+`Default XSL Stylesheet`:index:
+*******************************
 
 For reference, and as a starting point for your own stylesheets,
 the builtin stylesheet that pgadmin uses to render XHTML report output
diff --git a/docs/en_US/editgrid.rst b/docs/en_US/editgrid.rst
index 4f69680..a18611a 100644
--- a/docs/en_US/editgrid.rst
+++ b/docs/en_US/editgrid.rst
@@ -1,9 +1,9 @@
 .. _editgrid:
 
 
-*********
-Edit Data
-*********
+******************
+`Edit Data`:index:
+******************
 
 .. image:: images/editgrid.png
 
diff --git a/docs/en_US/export.rst b/docs/en_US/export.rst
index d8e1bae..5899257 100644
--- a/docs/en_US/export.rst
+++ b/docs/en_US/export.rst
@@ -1,9 +1,9 @@
 .. _export:
 
 
-*******************
-pgAdmin Data Export
-*******************
+****************************
+`pgAdmin Data Export`:index:
+****************************
 
 .. image:: images/export.png
 
diff --git a/docs/en_US/extend.rst b/docs/en_US/extend.rst
index 91885d9..318bb27 100644
--- a/docs/en_US/extend.rst
+++ b/docs/en_US/extend.rst
@@ -1,9 +1,9 @@
 .. _extend:
 
 
-*****************
-Extended features
-*****************
+**************************
+`Extended features`:index:
+**************************
 
 pgAdmin III's functionality can be further enhanced using the *adminpack* contrib
 module for PostgreSQL. This is a library of additional functions that may be installed 
diff --git a/docs/en_US/gqb.rst b/docs/en_US/gqb.rst
index 2e62922..a231f98 100644
--- a/docs/en_US/gqb.rst
+++ b/docs/en_US/gqb.rst
@@ -1,9 +1,9 @@
 .. _gqb:
 
 
-***********************
-Graphical Query builder
-***********************
+********************************
+`Graphical Query builder`:index:
+********************************
 
 .. image:: images/gqb.png
 
diff --git a/docs/en_US/grantwiz.rst b/docs/en_US/grantwiz.rst
index f5997a5..fe13c1c 100644
--- a/docs/en_US/grantwiz.rst
+++ b/docs/en_US/grantwiz.rst
@@ -1,9 +1,9 @@
 .. _grantwiz:
 
 
-************
-Grant Wizard
-************
+*********************
+`Grant Wizard`:index:
+*********************
 
 .. image:: images/grantwiz.png
 
diff --git a/docs/en_US/gridopts.rst b/docs/en_US/gridopts.rst
index 17dc838..9cd9a55 100644
--- a/docs/en_US/gridopts.rst
+++ b/docs/en_US/gridopts.rst
@@ -1,9 +1,9 @@
 .. _gridopts:
 
 
-*****************
-View Data Options
-*****************
+**************************
+`View Data Options`:index:
+**************************
 
 When "Apply Filter and View Data" is selected from the main menu,
 or the "Sort/Filter" toolbar button is pressed in the data viewer,
diff --git a/docs/en_US/guruhints.rst b/docs/en_US/guruhints.rst
index afbafb9..6a3a6e6 100644
--- a/docs/en_US/guruhints.rst
+++ b/docs/en_US/guruhints.rst
@@ -1,9 +1,9 @@
 .. _guruhints:
 
 
-**********
-Guru Hints
-**********
+*******************
+`Guru Hints`:index:
+*******************
 
 pgAdmin III has some functions included which should help to implement healthy 
 and good performing databases. They are the result of the long experience of the
diff --git a/docs/en_US/macros.rst b/docs/en_US/macros.rst
index a9bebb4..e7f55d9 100644
--- a/docs/en_US/macros.rst
+++ b/docs/en_US/macros.rst
@@ -1,9 +1,9 @@
 .. _macros:
 
 
-*****************
-Query Tool Macros
-*****************
+**************************
+`Query Tool Macros`:index:
+**************************
 
 .. image:: images/manage-macros.png
 
diff --git a/docs/en_US/main.rst b/docs/en_US/main.rst
index 4959598..40a3acf 100644
--- a/docs/en_US/main.rst
+++ b/docs/en_US/main.rst
@@ -1,9 +1,9 @@
 .. _main:
 
 
-*******************
-pgAdmin Main Window
-*******************
+****************************
+`pgAdmin Main Window`:index:
+****************************
 
 .. image:: images/main.png
 
diff --git a/docs/en_US/maintenance.rst b/docs/en_US/maintenance.rst
index d9dc7fa..26e932c 100644
--- a/docs/en_US/maintenance.rst
+++ b/docs/en_US/maintenance.rst
@@ -1,9 +1,9 @@
 .. _maintenance:
 
 
-**************************
-Maintain a database object
-**************************
+***********************************
+`Maintain a database object`:index:
+***********************************
 
 .. image:: images/maintenance.png
 
diff --git a/docs/en_US/options-tab1.rst b/docs/en_US/options-tab1.rst
index d706186..8878c4b 100644
--- a/docs/en_US/options-tab1.rst
+++ b/docs/en_US/options-tab1.rst
@@ -1,9 +1,9 @@
 .. _options-tab1:
 
 
-*********************************
-pgAdmin Options - Tab 1 (General)
-*********************************
+******************************************
+`pgAdmin Options - Tab 1 (General)`:index:
+******************************************
 
 .. image:: images/options-general.png
 
diff --git a/docs/en_US/options-tab2.rst b/docs/en_US/options-tab2.rst
index 5171ebb..0c1105c 100644
--- a/docs/en_US/options-tab2.rst
+++ b/docs/en_US/options-tab2.rst
@@ -1,9 +1,9 @@
 .. _options-tab2:
 
 
-*************************************
-pgAdmin Options - Tab 2 (Preferences)
-*************************************
+**********************************************
+`pgAdmin Options - Tab 2 (Preferences)`:index:
+**********************************************
 
 .. image:: images/options-preferences.png
 
diff --git a/docs/en_US/options-tab3.rst b/docs/en_US/options-tab3.rst
index 9e1a4ed..35f47b4 100644
--- a/docs/en_US/options-tab3.rst
+++ b/docs/en_US/options-tab3.rst
@@ -1,9 +1,9 @@
 .. _options-tab3:
 
 
-*********************************
-pgAdmin Options - Tab 3 (Browser)
-*********************************
+******************************************
+`pgAdmin Options - Tab 3 (Browser)`:index:
+******************************************
 
 .. image:: images/options-browser.png
 
diff --git a/docs/en_US/options-tab4.rst b/docs/en_US/options-tab4.rst
index 0204f89..5049ccf 100644
--- a/docs/en_US/options-tab4.rst
+++ b/docs/en_US/options-tab4.rst
@@ -1,9 +1,9 @@
 .. _options-tab4:
 
 
-************************************
-pgAdmin Options - Tab 4 (Query Tool)
-************************************
+*********************************************
+`pgAdmin Options - Tab 4 (Query Tool)`:index:
+*********************************************
 
 .. image:: images/options-querytool.png
 
diff --git a/docs/en_US/options-tab5.rst b/docs/en_US/options-tab5.rst
index 8abeebf..1a421ab 100644
--- a/docs/en_US/options-tab5.rst
+++ b/docs/en_US/options-tab5.rst
@@ -1,9 +1,9 @@
 .. _options-tab5:
 
 
-******************************************
-pgAdmin Options - Tab 5 (Query Tool Files)
-******************************************
+***************************************************
+`pgAdmin Options - Tab 5 (Query Tool Files)`:index:
+***************************************************
 
 .. image:: images/options-querytoolfiles.png
 
diff --git a/docs/en_US/options-tab6.rst b/docs/en_US/options-tab6.rst
index 7f142e7..6c424c6 100644
--- a/docs/en_US/options-tab6.rst
+++ b/docs/en_US/options-tab6.rst
@@ -1,9 +1,9 @@
 .. _options-tab6:
 
 
-*********************************
-pgAdmin Options - Tab 6 (Colours)
-*********************************
+******************************************
+`pgAdmin Options - Tab 6 (Colours)`:index:
+******************************************
 
 .. image:: images/options-colours.png
 
diff --git a/docs/en_US/options-tab7.rst b/docs/en_US/options-tab7.rst
index 77dd738..9ad2330 100644
--- a/docs/en_US/options-tab7.rst
+++ b/docs/en_US/options-tab7.rst
@@ -1,9 +1,9 @@
 .. _options-tab7:
 
 
-*********************************
-pgAdmin Options - Tab 7 (Logging)
-*********************************
+******************************************
+`pgAdmin Options - Tab 7 (Logging)`:index:
+******************************************
 
 .. image:: images/options-logging.png
 
diff --git a/docs/en_US/options.rst b/docs/en_US/options.rst
index f00b470..0ac6b26 100644
--- a/docs/en_US/options.rst
+++ b/docs/en_US/options.rst
@@ -1,9 +1,9 @@
 .. _options:
 
 
-***************
-pgAdmin Options
-***************
+************************
+`pgAdmin Options`:index:
+************************
 
 pgAdmin has a selection of configuration options to help it work
 as you prefer. If you think of an additional feature that should be
diff --git a/docs/en_US/password.rst b/docs/en_US/password.rst
index e2918fc..e3853fd 100644
--- a/docs/en_US/password.rst
+++ b/docs/en_US/password.rst
@@ -1,9 +1,9 @@
 .. _password:
 
 
-***************
-Change Password
-***************
+************************
+`Change Password`:index:
+************************
 
 .. image:: images/password.png
 
diff --git a/docs/en_US/pgagent-install.rst b/docs/en_US/pgagent-install.rst
index 97001f5..9c519b4 100644
--- a/docs/en_US/pgagent-install.rst
+++ b/docs/en_US/pgagent-install.rst
@@ -1,9 +1,9 @@
 .. _pgagent-install:
 
 
-********************
-pgAgent Installation
-********************
+*****************************
+`pgAgent Installation`:index:
+*****************************
 
 pgAgent runs as a daemon on Unix systems, and a service on Windows systems.
 In the majority of cases it will run on the database server itself - it is 
diff --git a/docs/en_US/pgagent-jobs.rst b/docs/en_US/pgagent-jobs.rst
index 84688fe..102bb3f 100644
--- a/docs/en_US/pgagent-jobs.rst
+++ b/docs/en_US/pgagent-jobs.rst
@@ -1,9 +1,9 @@
 .. _pgagent-jobs:
 
 
-************
-pgAgent Jobs
-************
+*********************
+`pgAgent Jobs`:index:
+*********************
 
 pgAgent runs 'jobs', each of which consists of :ref:`pgagent-steps` and 
 :ref:`pgagent-schedules`. To configure jobs on your
diff --git a/docs/en_US/pgagent-schedules.rst b/docs/en_US/pgagent-schedules.rst
index ffdcd94..05bde4e 100644
--- a/docs/en_US/pgagent-schedules.rst
+++ b/docs/en_US/pgagent-schedules.rst
@@ -1,9 +1,9 @@
 .. _pgagent-schedules:
 
 
-*****************
-pgAgent Schedules
-*****************
+**************************
+`pgAgent Schedules`:index:
+**************************
 
 Each Job is executed according to one or more schedules. Each time the
 job or any of its schedules are altered, the next runtime of the 
diff --git a/docs/en_US/pgagent-steps.rst b/docs/en_US/pgagent-steps.rst
index d8be431..3a6ba7e 100644
--- a/docs/en_US/pgagent-steps.rst
+++ b/docs/en_US/pgagent-steps.rst
@@ -1,9 +1,9 @@
 .. _pgagent-steps:
 
 
-*************
-pgAgent Steps
-*************
+**********************
+`pgAgent Steps`:index:
+**********************
 
 Each Job consists of a number of steps, each of which may be an SQL script,
 or an operating system batch/shell script. Each step in a given job is run in 
diff --git a/docs/en_US/pgscript.rst b/docs/en_US/pgscript.rst
index a026577..85ab52b 100644
--- a/docs/en_US/pgscript.rst
+++ b/docs/en_US/pgscript.rst
@@ -1,9 +1,9 @@
 .. _pgscript:
 
 
-*************************************
-pgScript Scripting Language Reference
-*************************************
+**********************************************
+`pgScript Scripting Language Reference`:index:
+**********************************************
 
 
 .. _pgscript-overview:
diff --git a/docs/en_US/query.rst b/docs/en_US/query.rst
index 633b312..39681e1 100644
--- a/docs/en_US/query.rst
+++ b/docs/en_US/query.rst
@@ -1,9 +1,9 @@
 .. _query:
 
 
-**********
-Query tool
-**********
+*******************
+`Query tool`:index:
+*******************
 
 .. image:: images/query.png
 
diff --git a/docs/en_US/reports.rst b/docs/en_US/reports.rst
index dd5a349..0e7e746 100644
--- a/docs/en_US/reports.rst
+++ b/docs/en_US/reports.rst
@@ -1,9 +1,9 @@
 .. _reports:
 
 
-***********
-Report Tool
-***********
+********************
+`Report Tool`:index:
+********************
 
 pgAdmin includes a simple reporting engine which allows you to quickly
 generate reports from the queries you write in the :ref:`Query Tool <query>`,
@@ -50,9 +50,9 @@ The default :ref:`XSL stylesheet <default-xsl>` used to render
 XHTML output can be used as a starting point for your own, and sample 
 :ref:`XML data <sample-xml>` may also be reviewed if required.
 
-Contents:
-
-.. toctree::
-   :maxdepth: 2
-
+Contents:
+
+.. toctree::
+   :maxdepth: 2
+
    default-xsl
\ No newline at end of file
diff --git a/docs/en_US/restore.rst b/docs/en_US/restore.rst
index 76204e0..972aced 100644
--- a/docs/en_US/restore.rst
+++ b/docs/en_US/restore.rst
@@ -1,9 +1,9 @@
 .. _restore:
 
 
-*******
-Restore
-*******
+****************
+`Restore`:index:
+****************
 
 .. image:: images/restore.png
 .. image:: images/restore-2.png
diff --git a/docs/en_US/sample-xml.rst b/docs/en_US/sample-xml.rst
index 5ea1c0f..ddaaff3 100644
--- a/docs/en_US/sample-xml.rst
+++ b/docs/en_US/sample-xml.rst
@@ -1,9 +1,9 @@
 .. _sample-xml:
 
 
-***************
-Sample XML Data
-***************
+************************
+`Sample XML Data`:index:
+************************
 
 The sample report below demonstrates the XML format that the
 pgadmin :ref:`Report Tool <reports>` will produce.
diff --git a/docs/en_US/search_object.rst b/docs/en_US/search_object.rst
index 1d7e928..2021c55 100644
--- a/docs/en_US/search_object.rst
+++ b/docs/en_US/search_object.rst
@@ -1,9 +1,9 @@
 .. _search_object:
 
 
-*************
-Object search
-*************
+**********************
+`Object search`:index:
+**********************
 
 .. image:: images/search.png
 
diff --git a/docs/en_US/slony-example.rst b/docs/en_US/slony-example.rst
index 7c3855f..1d5ef27 100644
--- a/docs/en_US/slony-example.rst
+++ b/docs/en_US/slony-example.rst
@@ -1,9 +1,9 @@
 .. _slony-example:
 
 
-********************************
-Slony-I example
-********************************
+************************
+`Slony-I example`:index:
+************************
 
 In this example, a master server is setup with two direct slaves. This example was
 written and tested using Slony-I v1.2.11 and PostgreSQL 8.2.5, running on a single
diff --git a/docs/en_US/slony-execute.rst b/docs/en_US/slony-execute.rst
index 6583e34..c9205d0 100644
--- a/docs/en_US/slony-execute.rst
+++ b/docs/en_US/slony-execute.rst
@@ -1,9 +1,9 @@
 .. _slony-execute:
 
 
-********************************
-Execute DDL scripts with Slony-I
-********************************
+*****************************************
+`Execute DDL scripts with Slony-I`:index:
+*****************************************
 
 .. image:: images/slony-execute.png
 
diff --git a/docs/en_US/slony-functions.rst b/docs/en_US/slony-functions.rst
index 75ef472..1dbee56 100644
--- a/docs/en_US/slony-functions.rst
+++ b/docs/en_US/slony-functions.rst
@@ -1,9 +1,9 @@
 .. _slony-functions:
 
 
-*************
-Slony-I tasks
-*************
+**********************
+`Slony-I tasks`:index:
+**********************
 
 In the appropriate context, pgAdmin III can trigger several maintenance tasks.
 
diff --git a/docs/en_US/slony-install.rst b/docs/en_US/slony-install.rst
index 145b274..200810a 100644
--- a/docs/en_US/slony-install.rst
+++ b/docs/en_US/slony-install.rst
@@ -1,9 +1,9 @@
 .. _slony-install:
 
 
-*****************************************************
-Slony-I administration with pgAdmin III: installation
-*****************************************************
+**************************************************************
+`Slony-I administration with pgAdmin III: installation`:index:
+**************************************************************
 
 .. _node:
 
diff --git a/docs/en_US/slony-overview.rst b/docs/en_US/slony-overview.rst
index fe62deb..9d39fbf 100644
--- a/docs/en_US/slony-overview.rst
+++ b/docs/en_US/slony-overview.rst
@@ -1,9 +1,9 @@
 .. _slony-overview:
 
 
-*********************************
-Slony-I with pgAdmin III overview
-*********************************
+******************************************
+`Slony-I with pgAdmin III overview`:index:
+******************************************
 
 .. image:: images/slony-overview.png
 
diff --git a/docs/en_US/slony-path.rst b/docs/en_US/slony-path.rst
index a6f0177..c5d553c 100644
--- a/docs/en_US/slony-path.rst
+++ b/docs/en_US/slony-path.rst
@@ -1,9 +1,9 @@
 .. _slony-path:
 
 
-**************************
-Creating paths and listens
-**************************
+***********************************
+`Creating paths and listens`:index:
+***********************************
 
 .. _path:
 
diff --git a/docs/en_US/slony-set.rst b/docs/en_US/slony-set.rst
index fbd90a2..b1b79db 100644
--- a/docs/en_US/slony-set.rst
+++ b/docs/en_US/slony-set.rst
@@ -1,9 +1,9 @@
 .. _slony-set:
 
 
-*******************************
-Creating sets and subscriptions
-*******************************
+****************************************
+`Creating sets and subscriptions`:index:
+****************************************
 
 .. _set:
 
diff --git a/docs/en_US/slony.rst b/docs/en_US/slony.rst
index df8f3a3..6039d86 100644
--- a/docs/en_US/slony.rst
+++ b/docs/en_US/slony.rst
@@ -1,8 +1,8 @@
 .. _slony:
 
 
-Slony-I support
-=============== 
+`Slony-I support`:index:
+========================
 
 pgAdmin III includes a frontend to Slony-I, the most popular master-slave
 replication solution for PostgreSQL. pgAdmin III  makes maintaining the
diff --git a/docs/en_US/status.rst b/docs/en_US/status.rst
index 91112bd..f838fcd 100644
--- a/docs/en_US/status.rst
+++ b/docs/en_US/status.rst
@@ -1,9 +1,9 @@
 .. _status:
 
 
-**********************
-Database Server Status
-**********************
+*******************************
+`Database Server Status`:index:
+*******************************
 
 .. image:: images/status.png
 